#!/bin/sh
# Prérecquis : imagemagick, peh, omxplayer
# On doit convertir les PDF en images
# Puis afficher toutes les images
# Puis balancer les vidéos
# Et on recommence

# TODO : Gérer la même chose avec les fichiers sur clef USB
# TODO-DONE : tester si les programmes utilisés sont présents.
# TODO : créer un script d'install qui fait tout : installation, lancement et configuration et mise à jour du cron
# TODO : si des dossiers sont absents de la clef USB, on les crée !
# TODO : on rajoute la gestion d'une URL avec un navigateur ?
# TODO : on gère les délais entre les images (avec une variable manuelle)


RACINE="."

#On compte le nombre de fichier de chaque type
IMGDIR="Images"
PDFDIR="PDF"
VIDDIR="Vidéos"
PDFJPGDIR="PDF2JPG"
LSIMAGES=`ls -a $RACINE/$IMGDIR | sed -e "/\.$/d" | wc -l`
LSPDF=`ls -a $RACINE/$PDFDIR | sed -e "/\.$/d" | wc -l`
LSVIDEOS=`ls -a $RACINE/$VIDDIR | sed -e "/\.$/d" | wc -l`

function testprog () {
	# teste si les programmes necessaires sont bien présents
	ERR=""
	if [ ! -e /usr/bin/convert ]; ERR+="imagemagick "; fi
	if [ ! -e /usr/bin/peh ]; ERR+="peh "; fi
	if [ ! -e /usr/bin/omxplayer ]; ERR+="omxplayer "; fi
	if [ ! $ERR=""];
	then
		echo "Il manque des programmes, merci de les instaler avec :"
		echo "sudo apt install $ERR"
	fi
}

function testdir () {
	# On teste si les dossiers existent, sinon on les crée.
	

}

function convpdf () {
#Conversion des PDF en images
if [ $LSPDF -gt 0 ];
then
	if [ ! -d  $RACINE/$PDF2JPGDIR ];
	then
		mkdir $RACINE/$PDF2JPGDIR
	# on convertit chaque image en PDF avec convert
	for file in $PDFDIR/*.pdf;
	do
                convert -density 300 $file PDF2JPG/$file.jpg
	done
fi


function affImg () {
# On recompte les images
if [ $LSIMAGES -gt 0 ];
then
	# On affiche les images avec feh qui fait un passage
	if [ -d $RACINE/Images ];
	then
		feh -Z -F -Y -q -z -r -D 6 $RACINE/Images
	fi
fi
}

function affVideos () {
# On fait tourner les Vidéos
if [ $LSVIDEOS -gt 0 ];
then
	# on efface le curseur
	setterm -cursor off
	# On définit le service à utiliser, ici OMXPLAYER
	SERVICE="omxplayer"
	# On scanne en boucle le dossier
	while true; do
        	if ps ax | grep -v grep | grep $SERVICE > /dev/null
        	then
	        	# le script plante parfois si la pause n'est pas assez longue
        		sleep 100; 
		else
		        for entry in $RACINE/$VIDDIR/*
		        do
                		clear
	                	omxplayer $entry > /dev/null
        		done
		fi
	done
fi


# On lance tout ça

convpdf()
sync
sleep 5

while true;
do
	affImg();
	affVideos();
	# Et on recommence
done
